searchNodes=[{"ref":"Kaffe.html","title":"Kaffe","type":"module","doc":"An opinionated, highly specific, Elixir wrapper around brod: the Erlang Kafka client. :coffee: NOTE: Although we&#39;re using this in production at Spreedly it is still under active development. The API may change and there may be serious bugs we&#39;ve yet to encounter."},{"ref":"Kaffe.html#start/2","title":"Kaffe.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Kaffe.Config.html","title":"Kaffe.Config","type":"module","doc":""},{"ref":"Kaffe.Config.html#client_cert/0","title":"Kaffe.Config.client_cert/0","type":"function","doc":""},{"ref":"Kaffe.Config.html#client_cert_key/0","title":"Kaffe.Config.client_cert_key/0","type":"function","doc":""},{"ref":"Kaffe.Config.html#decode_pem/1","title":"Kaffe.Config.decode_pem/1","type":"function","doc":""},{"ref":"Kaffe.Config.html#extract_der/1","title":"Kaffe.Config.extract_der/1","type":"function","doc":""},{"ref":"Kaffe.Config.html#extract_type_and_der/1","title":"Kaffe.Config.extract_type_and_der/1","type":"function","doc":""},{"ref":"Kaffe.Config.html#heroku_kafka_endpoints/0","title":"Kaffe.Config.heroku_kafka_endpoints/0","type":"function","doc":""},{"ref":"Kaffe.Config.html#parse_endpoints/1","title":"Kaffe.Config.parse_endpoints/1","type":"function","doc":"Transform the encoded string into a list of {charlist, port} tuples."},{"ref":"Kaffe.Config.html#sasl_config/1","title":"Kaffe.Config.sasl_config/1","type":"function","doc":""},{"ref":"Kaffe.Config.html#ssl_config/0","title":"Kaffe.Config.ssl_config/0","type":"function","doc":""},{"ref":"Kaffe.Config.html#ssl_config/1","title":"Kaffe.Config.ssl_config/1","type":"function","doc":""},{"ref":"Kaffe.Config.html#ssl_config/2","title":"Kaffe.Config.ssl_config/2","type":"function","doc":""},{"ref":"Kaffe.Config.html#url_endpoint_to_tuple/1","title":"Kaffe.Config.url_endpoint_to_tuple/1","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html","title":"Kaffe.Config.Consumer","type":"module","doc":""},{"ref":"Kaffe.Config.Consumer.html#async_message_ack/0","title":"Kaffe.Config.Consumer.async_message_ack/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#begin_offset/0","title":"Kaffe.Config.Consumer.begin_offset/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#client_consumer_config/0","title":"Kaffe.Config.Consumer.client_consumer_config/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#config_get/2","title":"Kaffe.Config.Consumer.config_get/2","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#config_get!/1","title":"Kaffe.Config.Consumer.config_get!/1","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#configuration/0","title":"Kaffe.Config.Consumer.configuration/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#consumer_group/0","title":"Kaffe.Config.Consumer.consumer_group/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#consumer_group_config/0","title":"Kaffe.Config.Consumer.consumer_group_config/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#default_client_consumer_config/0","title":"Kaffe.Config.Consumer.default_client_consumer_config/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#endpoints/0","title":"Kaffe.Config.Consumer.endpoints/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#heroku_kafka?/0","title":"Kaffe.Config.Consumer.heroku_kafka?/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#max_bytes/0","title":"Kaffe.Config.Consumer.max_bytes/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#max_wait_time/0","title":"Kaffe.Config.Consumer.max_wait_time/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#maybe_heroku_kafka_ssl/0","title":"Kaffe.Config.Consumer.maybe_heroku_kafka_ssl/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#message_handler/0","title":"Kaffe.Config.Consumer.message_handler/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#min_bytes/0","title":"Kaffe.Config.Consumer.min_bytes/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#offset_reset_policy/0","title":"Kaffe.Config.Consumer.offset_reset_policy/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#rebalance_delay_ms/0","title":"Kaffe.Config.Consumer.rebalance_delay_ms/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#sasl_options/0","title":"Kaffe.Config.Consumer.sasl_options/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#ssl_options/0","title":"Kaffe.Config.Consumer.ssl_options/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#subscriber_name/0","title":"Kaffe.Config.Consumer.subscriber_name/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#subscriber_retries/0","title":"Kaffe.Config.Consumer.subscriber_retries/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#subscriber_retry_delay_ms/0","title":"Kaffe.Config.Consumer.subscriber_retry_delay_ms/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#topics/0","title":"Kaffe.Config.Consumer.topics/0","type":"function","doc":""},{"ref":"Kaffe.Config.Consumer.html#worker_allocation_strategy/0","title":"Kaffe.Config.Consumer.worker_allocation_strategy/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html","title":"Kaffe.Config.Producer","type":"module","doc":""},{"ref":"Kaffe.Config.Producer.html#client_producer_config/0","title":"Kaffe.Config.Producer.client_producer_config/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#config_get/2","title":"Kaffe.Config.Producer.config_get/2","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#config_get!/1","title":"Kaffe.Config.Producer.config_get!/1","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#configuration/0","title":"Kaffe.Config.Producer.configuration/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#default_client_producer_config/0","title":"Kaffe.Config.Producer.default_client_producer_config/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#endpoints/0","title":"Kaffe.Config.Producer.endpoints/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#heroku_kafka?/0","title":"Kaffe.Config.Producer.heroku_kafka?/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#maybe_heroku_kafka_ssl/0","title":"Kaffe.Config.Producer.maybe_heroku_kafka_ssl/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#producer_topics/0","title":"Kaffe.Config.Producer.producer_topics/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#sasl_options/0","title":"Kaffe.Config.Producer.sasl_options/0","type":"function","doc":""},{"ref":"Kaffe.Config.Producer.html#ssl_options/0","title":"Kaffe.Config.Producer.ssl_options/0","type":"function","doc":""},{"ref":"Kaffe.Consumer.html","title":"Kaffe.Consumer","type":"module","doc":"Consume messages from Kafka and pass to a given local module. See start_link/4 for details on how to start a Consumer process. As messages are consumed from Kafka they will be sent to your handle_message/1 (sync) or handle_message/2 (async) functions for processing in your system. Those functions must return :ok. Kaffe.Consumer commits offsets to Kafka which is very reliable but not immediate. If your application restarts then it&#39;s highly likely you&#39;ll reconsume some messages, especially for a quickly moving topic. Be ready!"},{"ref":"Kaffe.Consumer.html#ack/2","title":"Kaffe.Consumer.ack/2","type":"function","doc":"Acknowledge the Kafka message as processed. pid - the pid your handle_message/2 function was given as the first argument message - the Kafka message your handle_message/2 function was given as the second argument Kaffe.Consumer.ack(pid, message)"},{"ref":"Kaffe.Consumer.html#handle_message/4","title":"Kaffe.Consumer.handle_message/4","type":"function","doc":"Call the message handler with the restructured Kafka message. Kafka messages come from brod as an Erlang record. To make processing simpler for clients we convert that to an Elixir map. Since the consumer can subscribe to multiple topics with multiple partitions we also add the topic and partition as additional fields. After compiling the Kafka message your message handler module&#39;s handle_message function will be called. If async is false: Your message handler module&#39;s handle_message/1 function will be called with the message The Consumer will block and wait for your handle_message function to complete and then automatically acknowledge the message as processed. If async is true: Your message handler module&#39;s handle_message/2 function will be called with the pid of the running Consumer process and the message. Message intake on the Consumer will not wait for your handle_message/2 to complete and will not automatically acknowledge the message as processed. Once you&#39;ve processed the message you will need to call Kaffe.Consumer.ack/2 with the pid and message."},{"ref":"Kaffe.Consumer.html#init/2","title":"Kaffe.Consumer.init/2","type":"function","doc":"Initialize the consumer loop."},{"ref":"Kaffe.Consumer.html#kafka_message/1","title":"Kaffe.Consumer.kafka_message/1","type":"macro","doc":""},{"ref":"Kaffe.Consumer.html#kafka_message/2","title":"Kaffe.Consumer.kafka_message/2","type":"macro","doc":""},{"ref":"Kaffe.Consumer.html#start_consumer_client/1","title":"Kaffe.Consumer.start_consumer_client/1","type":"function","doc":""},{"ref":"Kaffe.Consumer.html#start_link/0","title":"Kaffe.Consumer.start_link/0","type":"function","doc":"Start a Kafka consumer The consumer pulls in values from the Kaffe consumer configuration: heroku_kafka_env - endpoints and SSL configuration will be pulled from ENV endpoints - plaintext Kafka endpoints consumer_group - the consumer group id (should be unique to your app) topics - a list of Kafka topics to consume message_handler - the module that will be called for each Kafka message async_message_ack - if false Kafka offset will automatically acknowledge after successful message parsing start_with_earliest_message - If true the worker will consume from the beginning of the topic when it first starts. This only affects consumer behavior before the consumer group starts recording its offsets in Kafka. Note: If async_message_ack is true then you&#39;ll need to call ack/2 to acknowledge Kafka messages as processed. Only use async processing if absolutely needed by your application&#39;s processing flow. With automatic (sync) acknowledgement then the message flow from Kaffe.Consumer has backpressure from your system. With manual (async) acknowledgement you will be able to process messages faster but will need to take on the burden of ensuring no messages are lost."},{"ref":"Kaffe.Consumer.State.html","title":"Kaffe.Consumer.State","type":"module","doc":"Running state for the consumer. message_handler - The module to call with each Kafka message async - Kafka offset processing behavior"},{"ref":"Kaffe.GroupManager.html","title":"Kaffe.GroupManager","type":"module","doc":"This is the main process for bootstrapping the full supervision tree to consume a Kafka topic via a subscriber/worker combo per topic per partition as part of a consumer group. See Kaffe.GroupMemberSupervisor for distinct components. The process begins by starting the client connection to Kafka. Then group members are created for each of the configured topics. Note that this module is is not involved in any message processing, rather it&#39;s role is to ensure that all of the relevant services are running."},{"ref":"Kaffe.GroupManager.html#child_spec/1","title":"Kaffe.GroupManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Kaffe.GroupManager.html#handle_call/3","title":"Kaffe.GroupManager.handle_call/3","type":"function","doc":"List the currently subscribed topics"},{"ref":"Kaffe.GroupManager.html#handle_cast/2","title":"Kaffe.GroupManager.handle_cast/2","type":"function","doc":"Start the subscribers and workers to process message sets Worker are booted before the subscribers so when the subscribers receive the first messages, we know there will be a worker to do the actual processing work"},{"ref":"Kaffe.GroupManager.html#init/1","title":"Kaffe.GroupManager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Kaffe.GroupManager.html#list_subscribed_topics/0","title":"Kaffe.GroupManager.list_subscribed_topics/0","type":"function","doc":"List of currently subscribed topics."},{"ref":"Kaffe.GroupManager.html#start_link/0","title":"Kaffe.GroupManager.start_link/0","type":"function","doc":""},{"ref":"Kaffe.GroupManager.html#subscribe_to_topics/1","title":"Kaffe.GroupManager.subscribe_to_topics/1","type":"function","doc":"Dynamically subscribe to topics in addition to the configured topics. Returns the newly subscribed topics. This may not include all values if any are already subscribed to."},{"ref":"Kaffe.GroupManager.State.html","title":"Kaffe.GroupManager.State","type":"module","doc":"The running state of the consumer group manager."},{"ref":"Kaffe.GroupMember.html","title":"Kaffe.GroupMember","type":"module","doc":"Note: The brod_group_member behavior is used. Consume messages from a Kafka topic for a consumer group. There is one brod group member per topic! So as new topics are added to configuration so are the number of brod group members. Likewise, if you&#39;re using something like Heroku Kafka and have multiple dynos for your consumer, there will be a Kaffe.GroupMember per dyno and each group member will receive a equal set of partition assignments for each topic. The actual consumption is delegated to a series of subscribers, see Kaffe.Subscriber for details on how messages are processed. The subscribers are assigned generations. Each generation represents a specific configuration. In order to allow the partitions to be rebalanced on startup, there is a delay between receiving a set of assignments associated with that generation and actually creating the subscribers. If a new generation is received in the mean time, the older generation is discarded. See the follow for more details: https://github.com/klarna/brod/blob/master/src/brod_group_member.erl https://github.com/klarna/brucke/blob/master/src/brucke_member.erl"},{"ref":"Kaffe.GroupMember.html#assign_partitions/3","title":"Kaffe.GroupMember.assign_partitions/3","type":"function","doc":"Callback implementation for c::brod_group_member.assign_partitions/3."},{"ref":"Kaffe.GroupMember.html#assignments_received/4","title":"Kaffe.GroupMember.assignments_received/4","type":"function","doc":"Callback implementation for c::brod_group_member.assignments_received/4."},{"ref":"Kaffe.GroupMember.html#assignments_revoked/1","title":"Kaffe.GroupMember.assignments_revoked/1","type":"function","doc":"Callback implementation for c::brod_group_member.assignments_revoked/1."},{"ref":"Kaffe.GroupMember.html#child_spec/1","title":"Kaffe.GroupMember.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Kaffe.GroupMember.html#get_committed_offsets/2","title":"Kaffe.GroupMember.get_committed_offsets/2","type":"function","doc":"Callback implementation for c::brod_group_member.get_committed_offsets/2."},{"ref":"Kaffe.GroupMember.html#init/1","title":"Kaffe.GroupMember.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Kaffe.GroupMember.html#start_link/4","title":"Kaffe.GroupMember.start_link/4","type":"function","doc":""},{"ref":"Kaffe.GroupMember.State.html","title":"Kaffe.GroupMember.State","type":"module","doc":""},{"ref":"Kaffe.GroupMemberSupervisor.html","title":"Kaffe.GroupMemberSupervisor","type":"module","doc":"The top-level supervisor for consumer group members. Consuming messages from a Kafka topic as part of a consumer group is broken out into the following distinct components: GroupMember Subscriber Worker WorkerManager WorkerSupervisor The GroupMember implements the :brod_group_member behaviour and is responsible for receiving assignments from Kafka and managing how subscribers and workers are configured and allocated. All message processing is then delegated to the created Subscribers and Workers. Subscribers subscribe to Kafka topics and are responsble for receiving lists of messages, passing messages to workers for processing, and committing offsets after processing. Workers wrap application message handlers and notify subscribers about whether or not commit offsets back to Kafka."},{"ref":"Kaffe.GroupMemberSupervisor.html#child_spec/1","title":"Kaffe.GroupMemberSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Kaffe.GroupMemberSupervisor.html#init/1","title":"Kaffe.GroupMemberSupervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Kaffe.GroupMemberSupervisor.html#start_group_member/5","title":"Kaffe.GroupMemberSupervisor.start_group_member/5","type":"function","doc":""},{"ref":"Kaffe.GroupMemberSupervisor.html#start_link/0","title":"Kaffe.GroupMemberSupervisor.start_link/0","type":"function","doc":""},{"ref":"Kaffe.GroupMemberSupervisor.html#start_worker_supervisor/2","title":"Kaffe.GroupMemberSupervisor.start_worker_supervisor/2","type":"function","doc":""},{"ref":"Kaffe.PartitionSelector.html","title":"Kaffe.PartitionSelector","type":"module","doc":""},{"ref":"Kaffe.PartitionSelector.html#md5/2","title":"Kaffe.PartitionSelector.md5/2","type":"function","doc":""},{"ref":"Kaffe.PartitionSelector.html#random/1","title":"Kaffe.PartitionSelector.random/1","type":"function","doc":""},{"ref":"Kaffe.PartitionSelector.html#round_robin/2","title":"Kaffe.PartitionSelector.round_robin/2","type":"function","doc":"Cycle current from 0 to total-1. Examples iex&gt; Kaffe.PartitionSelector.round_robin(nil, 3) 0 iex&gt; Kaffe.PartitionSelector.round_robin(0, 3) 1 iex&gt; Kaffe.PartitionSelector.round_robin(1, 3) 2 iex&gt; Kaffe.PartitionSelector.round_robin(2, 3) 0"},{"ref":"Kaffe.Producer.html","title":"Kaffe.Producer","type":"module","doc":"The producer pulls in values from the Kaffe producer configuration: heroku_kafka_env - endpoints and SSL configuration will be pulled from ENV endpoints - plaintext Kafka endpoints topics - a list of Kafka topics to prep for producing partition_strategy - the strategy to use when selecting the next partition. Default :md5. :md5: provides even and deterministic distrbution of the messages over the available partitions based on an MD5 hash of the key :random - Select a random partition function - Pass a function as an argument that accepts five arguments and returns the partition number to use for the message topic, current_partition, partitions_count, key, value Clients can also specify a partition directly when producing. Currently only synchronous production is supported."},{"ref":"Kaffe.Producer.html#produce/3","title":"Kaffe.Producer.produce/3","type":"function","doc":"Synchronously produce the messages_list to topic messages_list must be a list of {key, value} tuples opts may include the partition strategy to use, partition_strategy: :md5, or :random or a function. Returns: * `:ok` on successfully producing each message * `{:error, reason}` for any error"},{"ref":"Kaffe.Producer.html#produce_sync/2","title":"Kaffe.Producer.produce_sync/2","type":"function","doc":"Synchronously produce the given key/value to the first Kafka topic. This is a simpler way to produce if you&#39;ve only given Producer a single topic for production and don&#39;t want to specify the topic for each call. Returns: * `:ok` on successfully producing the message * `{:error, reason}` for any error"},{"ref":"Kaffe.Producer.html#produce_sync/3","title":"Kaffe.Producer.produce_sync/3","type":"function","doc":"Synchronously produce the key/value to topic See produce_sync/2 for returns."},{"ref":"Kaffe.Producer.html#produce_sync/4","title":"Kaffe.Producer.produce_sync/4","type":"function","doc":"Synchronously produce the given key/value to the topic/partition See produce_sync/2 for returns."},{"ref":"Kaffe.Producer.html#start_producer_client/0","title":"Kaffe.Producer.start_producer_client/0","type":"function","doc":""},{"ref":"Kaffe.Subscriber.html","title":"Kaffe.Subscriber","type":"module","doc":"Consume messages from a single partition of a single Kafka topic. Assignments are received from a group consumer member, Kaffe.GroupMember. Messages are delegated to Kaffe.Worker. The worker is expected to cast back a response, at which time the stored offset will be acked back to Kafka. The options (ops) to subscribe/7 may include the beginning offset using :begin_offset. The subscriber reads the following options out of the configuration: - `max_bytes` - The maximum number of message bytes to receive in a batch - `min_bytes` - The minimum number of message bytes to receive in a batch - `max_wait_time` - Maximum number of milliseconds broker will wait for `:min_bytes` of messages to be collected - `offset_reset_policy` - The native `auto.offset.reset` option, either `:reset_to_earliest` or `:reset_to_latest`. See: https://github.com/klarna/brucke/blob/master/src/brucke_member.erl Also: https://github.com/klarna/brod/blob/master/src/brod_consumer.erl"},{"ref":"Kaffe.Subscriber.html#child_spec/1","title":"Kaffe.Subscriber.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Kaffe.Subscriber.html#commit_offsets/5","title":"Kaffe.Subscriber.commit_offsets/5","type":"function","doc":""},{"ref":"Kaffe.Subscriber.html#init/1","title":"Kaffe.Subscriber.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Kaffe.Subscriber.html#kafka_message/1","title":"Kaffe.Subscriber.kafka_message/1","type":"macro","doc":""},{"ref":"Kaffe.Subscriber.html#kafka_message/2","title":"Kaffe.Subscriber.kafka_message/2","type":"macro","doc":""},{"ref":"Kaffe.Subscriber.html#kafka_message_set/1","title":"Kaffe.Subscriber.kafka_message_set/1","type":"macro","doc":""},{"ref":"Kaffe.Subscriber.html#kafka_message_set/2","title":"Kaffe.Subscriber.kafka_message_set/2","type":"macro","doc":""},{"ref":"Kaffe.Subscriber.html#request_more_messages/2","title":"Kaffe.Subscriber.request_more_messages/2","type":"function","doc":""},{"ref":"Kaffe.Subscriber.html#stop/1","title":"Kaffe.Subscriber.stop/1","type":"function","doc":""},{"ref":"Kaffe.Subscriber.html#subscribe/7","title":"Kaffe.Subscriber.subscribe/7","type":"function","doc":""},{"ref":"Kaffe.Subscriber.State.html","title":"Kaffe.Subscriber.State","type":"module","doc":""},{"ref":"Kaffe.Worker.html","title":"Kaffe.Worker","type":"module","doc":"A worker receives messages for a single topic for a single partition. Processing the message set is delegated to the configured message handler. It&#39;s responsible for any error handling as well. The message handler must define a handle_messages function (note the pluralization!) to accept a list of messages. The result of handle_messages is sent back to the subscriber. Additionally, the message handler should inform the subscriber on what to do with the offsets after processing the message set."},{"ref":"Kaffe.Worker.html#handle_cast/2","title":"Kaffe.Worker.handle_cast/2","type":"function","doc":"Entry point for processing a message set received by a subscriber. Note that the response from the message handler is what dictates how a subscriber should deal with the message offset. Depending on the situation, a message processor may not want to have it&#39;s most recent offsets committed."},{"ref":"Kaffe.Worker.html#init/1","title":"Kaffe.Worker.init/1","type":"function","doc":""},{"ref":"Kaffe.Worker.html#process_messages/6","title":"Kaffe.Worker.process_messages/6","type":"function","doc":""},{"ref":"Kaffe.Worker.html#start_link/3","title":"Kaffe.Worker.start_link/3","type":"function","doc":""},{"ref":"Kaffe.Worker.html#terminate/2","title":"Kaffe.Worker.terminate/2","type":"function","doc":""},{"ref":"Kaffe.WorkerManager.html","title":"Kaffe.WorkerManager","type":"module","doc":"Manage topic/partition-to-worker assignments. Subscribers get workers from here. This process manages the workers, while delegating to Kaffe.WorkerSupervisor to start each worker under supervision. Workers are allocated based on a configured strategy (worker_allocation_strategy in the consumer config): either one worker per topic/partition, or one worker for a partition across topics. The first strategy is useful for higher throughput and increased flexibility. The second is useful when mutliple input topics may have the same messages (identified by key) and those messages must be processsed sequentially. The table of workers is stored in an ETS table, :kaffe_workers."},{"ref":"Kaffe.WorkerManager.html#child_spec/1","title":"Kaffe.WorkerManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Kaffe.WorkerManager.html#init/1","title":"Kaffe.WorkerManager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Kaffe.WorkerManager.html#start_link/1","title":"Kaffe.WorkerManager.start_link/1","type":"function","doc":""},{"ref":"Kaffe.WorkerManager.html#worker_for/3","title":"Kaffe.WorkerManager.worker_for/3","type":"function","doc":""},{"ref":"Kaffe.WorkerManager.html#worker_name/2","title":"Kaffe.WorkerManager.worker_name/2","type":"function","doc":""},{"ref":"Kaffe.WorkerSupervisor.html","title":"Kaffe.WorkerSupervisor","type":"module","doc":"Supervise the individual workers."},{"ref":"Kaffe.WorkerSupervisor.html#child_spec/1","title":"Kaffe.WorkerSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Kaffe.WorkerSupervisor.html#init/1","title":"Kaffe.WorkerSupervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Kaffe.WorkerSupervisor.html#start_link/1","title":"Kaffe.WorkerSupervisor.start_link/1","type":"function","doc":""},{"ref":"Kaffe.WorkerSupervisor.html#start_worker/4","title":"Kaffe.WorkerSupervisor.start_worker/4","type":"function","doc":""},{"ref":"Kaffe.WorkerSupervisor.html#start_worker_manager/2","title":"Kaffe.WorkerSupervisor.start_worker_manager/2","type":"function","doc":""}]